\name{hexVP-class}
\docType{class}
\alias{hexVP-class}
\alias{getFig,hexVP-method}
\alias{getMargins,hexVP-method}
\alias{getPlt,hexVP-method}
\alias{getXscale,hexVP-method}
\alias{getYscale,hexVP-method}

\title{Formal class "hexVP" of a Hexagon Viewport}
\description{
  Hexagon Viewports are \dQuote{value-added} grid viewports (see
  \code{\link{viewport}}) where the extra slots contain scaling and
  \dQuote{embedding} information.
}
\section{Objects from the Class}{
  Objects are typically created by calls to \code{\link{hexViewport}()}
  or by low level calls of the form \code{new("hexVP", ...)}.
}
\section{Slots}{
  \describe{
    \item{\code{hexVp}:}{Object of class \code{"viewport"}, see
      \code{\link[grid]{viewport}}.}
    \item{\code{mar}:}{\code{\link{unit}} vector of four margins
      (typically in \code{"lines"}).}
    \item{\code{fig}:}{\code{\link{unit}} vector of two figure sizes
      (typically in \code{"npc"}).}
    \item{\code{plt}:}{\code{\link{unit}} vector of two figure sizes
      (typically in \code{"npc"}).}
%% MM {FIXME?}: Is n't this simply ``xlim'' - then call it so!
    \item{\code{xscale}:}{numeric of length two specifying x-scaling.}
    \item{\code{yscale}:}{numeric of length two specifying y-scaling.}
  }
}
\section{Methods}{
  These are methods accessing the slots of corresponding name.
  \describe{
    \item{getFig}{\code{signature(hvp = "hexVP")}: ... }
    \item{getMargins}{\code{signature(hvp = "hexVP")}: ... }
    \item{getPlt}{\code{signature(hvp = "hexVP")}: ... }
    \item{getXscale}{\code{signature(hvp = "hexVP")}: ... }
    \item{getYscale}{\code{signature(hvp = "hexVP")}: ... }
  }
}
\author{
  Nicholas Lewin-Koh \email{kohnicho@comp.nus.edu.sg}.
}
\seealso{
  The constructor function \code{\link{hexViewport}}.
  \code{\link{hexbin}}, and its S4 plotting method,
  \code{\link{gplot.hexbin}}.
}
\examples{
 example(hexViewport, echo=FALSE)
 ## continued:
 str(P$plot.vp)
}
\keyword{classes}
