library(hexbin)
set.seed(545)

## a variation on Nicholas' post to bioconductor:
x <- rnorm(2^15)
y <- 3*x - .2*x^2 + rnorm(2^15)
hbin <- hexbin(x,y)
hp <- hexViewport(hbin, ## offset = unit(1.2,"inches"),
                  newpage = TRUE)
pushViewport(hp)
grid.rect()
grid.xaxis()
grid.yaxis()
grid.hexagons(hbin, style = "centroid")
hloess <- loess(y~x, data = hcell2xy(hbin),
                weights = hbin @ count)
xx <- seq(hbin@xbnds[1], hbin@xbnds[2], length = 500)
grid.lines(xx, predict(hloess, xx),
           gp = gpar(col = 'red', lwd = 2), default.units = "native")
popViewport()
